/* * Copyright (c) 2015, Freescale Semiconductor, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * o Redistributions of source code must retain the above copyright notice, this list
 *   of conditions and the following disclaimer.
 *
 * o Redistributions in binary form must reproduce the above copyright notice, this
 *   list of conditions and the following disclaimer in the documentation and/or
 *   other materials provided with the distribution.
 *
 * o Neither the name of Freescale Semiconductor, Inc. nor the names of its
 *   contributors may be used to endorse or promote products derived from this
 *   software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
 
#ifndef __CH_LIB_FTM_H_
#define	__CH_LIB_FTM_H_

#ifdef __cplusplus
	extern "C" {
#endif

#include <stdint.h>
#include <stdbool.h>

/* FTM Ӳģ */
#define HW_FTM0    (0x00)
#define HW_FTM1    (0x01) 
#define HW_FTM2    (0x02)
#define HW_FTM3    (0x03)

/* FTMõͨ */
#define HW_FTM_CH0 (0x00)
#define HW_FTM_CH1 (0x01)
#define HW_FTM_CH2 (0x02)
#define HW_FTM_CH3 (0x03)
#define HW_FTM_CH4 (0x04)
#define HW_FTM_CH5 (0x05)
#define HW_FTM_CH6 (0x06)
#define HW_FTM_CH7 (0x07)

/* PWM  */
typedef enum
{
	kPWM_EdgeAligned,           //ض 
	kPWM_Combine,               //ģʽ
    kPWM_Complementary,         //ģʽ ģʽ Chl(n)  Chl(n+1) ǻ
}FTM_PWM_Mode_Type;
/* PWM Էת */
#define kFTM_PWM_HighTrue       (0x00)
#define kFTM_PWM_LowTrue        (0x01)

/** QD  */
typedef enum
{
    kFTM_QD_NormalPolarity,     /*  */
    kFTM_QD_InvertedPolarity,   /* */
}FTM_QD_PolarityMode_Type;
 
typedef enum
{
	kQD_PHABEncoding,           /* ʹAB */
	kQD_CountDirectionEncoding, /* ʹ÷-ͱ */
}FTM_QD_Mode_Type;

/* IC 벶׽ */
typedef enum
{
	kFTM_IC_FallingEdge,
	kFTM_IC_RisingEdge,
	kFTM_IC_RisingFallingEdge,
}FTM_IC_Mode_Type;

//!< FTM жϼDMA 
typedef enum
{
    kFTM_IT_TOF,
    kFTM_IT_CH0,
    kFTM_IT_CH1,
    kFTM_IT_CH2,
    kFTM_IT_CH3,
    kFTM_IT_CH4,
    kFTM_IT_CH5,
    kFTM_IT_CH6,
    kFTM_IT_CH7,
    kFTM_DMA_CH0,
    kFTM_DMA_CH1,
    kFTM_DMA_CH2,
    kFTM_DMA_CH3,
    kFTM_DMA_CH4,
    kFTM_DMA_CH5,
    kFTM_DMA_CH6,
    kFTM_DMA_CH7,
}FTM_ITDMAConfig_Type;

/* Ƶ */
typedef enum
{
    kFTM_ClockDiv1,
    kFTM_ClockDiv2,
    kFTM_ClockDiv4,
    kFTM_ClockDiv8,
    kFTM_ClockDiv16,
    kFTM_ClockDiv32,
    kFTM_ClockDiv64,
    kFTM_ClockDiv128,
}FTM_ClockDiv_Type;





//!< FTM PWM ٳʼ


#define    FTM3_CH0_PE05        (0x004BA3U)
#define    FTM3_CH1_PE06        (0x084DA3U)
#define    FTM0_CH5_PA00        (0x2840C0U)
#define    FTM0_CH6_PA01        (0x3042C0U)
#define    FTM0_CH7_PA02        (0x3844C0U)
#define    FTM0_CH0_PA03        (0x0046C0U)
#define    FTM0_CH1_PA04        (0x0848C0U)
#define    FTM0_CH2_PA05        (0x104AC0U)
#define    FTM2_CH0_PA10        (0x0054C2U)
#define    FTM2_CH1_PA11        (0x0856C2U)
#define    FTM1_CH0_PA12        (0x0058C1U)
#define    FTM1_CH1_PA13        (0x085AC1U)
#define    FTM1_CH0_PB00        (0x0040C9U) 
#define    FTM1_CH1_PB01        (0x0842C9U)  
#define    FTM2_CH0_PB18        (0x0064CAU) 
#define    FTM2_CH1_PB19        (0x0866CAU) 
#define    FTM0_CH0_PC01        (0x004310U) 
#define    FTM0_CH1_PC02        (0x084510U) 
#define    FTM0_CH2_PC03        (0x104710U) 
#define    FTM0_CH3_PC04        (0x184910U) 
#define    FTM0_CH2_PC05        (0x104BD0U) 
#define    FTM3_CH4_PC08        (0x2050D3U) 
#define    FTM3_CH5_PC09        (0x2852D3U) 
#define    FTM3_CH6_PC10        (0x3054D3U) 
#define    FTM3_CH7_PC11        (0x3856D3U)  
#define    FTM3_CH0_PD00        (0x00411BU)   
#define    FTM3_CH1_PD01        (0x08431BU)   
#define    FTM3_CH2_PD02        (0x10451BU) 
#define    FTM3_CH3_PD03        (0x18471BU) 
#define    FTM0_CH4_PD04        (0x204918U) 
#define    FTM0_CH5_PD05        (0x284B18U) 
#define    FTM0_CH6_PD06        (0x304D18U) 
#define    FTM0_CH7_PD07        (0x384F18U) 






//!< FTM ٳʼ
#define FTM2_QD_PHA_PA10_PHB_PA11       (0X009982U) /* FTM1ģPTA8PTA9Ϊ */
#define FTM1_QD_PHA_PA12_PHB_PA13       (0X009982U)
#define FTM1_QD_PHA_PB00_PHB_PB01       (0X0099C1U)
#define FTM2_QD_PHA_PB18_PHB_PB19       (0X00A58AU)


//!< Callback
typedef void (*FTM_CallBackType)(void);

//!< API functions

/* PWM functions */
uint8_t FTM_PWM_QuickInit(uint32_t MAP, FTM_PWM_Mode_Type mode, uint32_t req);
void FTM_PWM_ChangeDuty(uint32_t instance, uint8_t chl, uint32_t pwmDuty);
void FTM_PWM_InvertPolarity(uint32_t instance, uint8_t chl, uint32_t config);
/* QD functions */
uint32_t FTM_QD_QuickInit(uint32_t MAP, FTM_QD_PolarityMode_Type polarity, FTM_QD_Mode_Type mode);
void FTM_QD_GetData(uint32_t instance, int* value, uint8_t* direction);
void FTM_QD_ClearCount(uint32_t instance);
/* IC functions */
void FTM_IC_QuickInit(uint32_t MAP, FTM_ClockDiv_Type ps);
void FTM_IC_SetTriggerMode(uint32_t instance, uint32_t chl, FTM_IC_Mode_Type mode);
/* IT & DMA config */
void FTM_ITDMAConfig(uint32_t instance, FTM_ITDMAConfig_Type config, bool flag);
void FTM_CallbackInstall(uint32_t instance, FTM_CallBackType AppCBFun);
/* control function */
uint32_t FTM_GetChlCounter(uint32_t instance, uint32_t chl);
void FTM_SetMoudleCounter(uint32_t instance, uint32_t val);




#ifdef __cplusplus
}
#endif





#endif
