/* * Copyright (c) 2015, Freescale Semiconductor, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * o Redistributions of source code must retain the above copyright notice, this list
 *   of conditions and the following disclaimer.
 *
 * o Redistributions in binary form must reproduce the above copyright notice, this
 *   list of conditions and the following disclaimer in the documentation and/or
 *   other materials provided with the distribution.
 *
 * o Neither the name of Freescale Semiconductor, Inc. nor the names of its
 *   contributors may be used to endorse or promote products derived from this
 *   software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
 
#ifndef __CH_LIB_LPTMR_H__
#define __CH_LIB_LPTMR_H__

#include <stdint.h>
#include <stdbool.h>


/* LPTMR ص */
typedef void (*LPTMR_CallBackType)(void);

/* LPTMR жDMA */
typedef enum
{
    kLPTMR_IT_TOF,            /* ж */
}LPTMR_ITDMAConfig_Type;

/* LPTMR ʱ ʼ */
typedef struct
{
    uint16_t        timeInMs;  //ʱʱ
}LPTMR_TC_InitTypeDef;

/* LPTMR Դѡ */
typedef enum
{
    kLPTMR_PC_InputSource_CMP0, /* CMP0 ΪʱԴ */
    kLPTMR_PC_InputSource_ALT1, /* ⲿLPTMR_ALT1ΪⲿʱԴ */
    kLPTMR_PC_InputSource_ALT2, /* ⲿLPTMR_ALT2ΪⲿʱԴ */
}LPTMR_PC_IntputSource_Type;

/* LPTMR ⲿΪʱ ѡ */
typedef enum
{
    kLPTMR_PC_PinPolarity_RigsingEdge,  /* ش */
    kLPTMR_PC_PinPolarity_FallingEdge,  /* ½ش */
}LPTMR_PC_PinPolarity_Type;

/* LPTMR ⲿ·弼 ʼ */
typedef struct
{
    uint16_t                        counterOverflowValue;   /* ۼֵ 0xFFFF */
    LPTMR_PC_IntputSource_Type      inputSource;            /* Դѡ */
    LPTMR_PC_PinPolarity_Type       pinPolarity;            /* 벶׽ѡ */
}LPTMR_PC_InitTypeDef;

//!< ٳʼṹ ڵ·
#define LPTMR_ALT1_PA19   (0x86780U)   /* ʹPTA19ΪԴ */
#define LPTMR_ALT2_PC05   (0x104b10U)  /* ʹPTC05ΪԴ */

//!< API functions
void LPTMR_TC_Init(LPTMR_TC_InitTypeDef* LPTMR_TC_InitStruct);
void LPTMR_PC_Init(LPTMR_PC_InitTypeDef* LPTMR_PC_InitStruct);
void LPTMR_ITDMAConfig(LPTMR_ITDMAConfig_Type config, bool status);
void LPTMR_CallbackInstall(LPTMR_CallBackType AppCBFun);
uint32_t LPTMR_PC_ReadCounter(void);
uint32_t LPTMR_PC_QuickInit(uint32_t MAP);
void LPTMR_ClearCounter(void);

#endif

