/* * Copyright (c) 2015, Freescale Semiconductor, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * o Redistributions of source code must retain the above copyright notice, this list
 *   of conditions and the following disclaimer.
 *
 * o Redistributions in binary form must reproduce the above copyright notice, this
 *   list of conditions and the following disclaimer in the documentation and/or
 *   other materials provided with the distribution.
 *
 * o Neither the name of Freescale Semiconductor, Inc. nor the names of its
 *   contributors may be used to endorse or promote products derived from this
 *   software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
 
#ifndef __CH_LIB_PDB_H__
#define __CH_LIB_PDB_H__

#ifdef __cplusplus
 extern "C" {
#endif
	 
#include "common.h"
#include <stdint.h>
     
    
#define HW_PDB_CH0
#define HW_PDB_CH1
     
#define HW_PDB_TRIG_CH0
#define HW_PDB_TRIG_CH1
     
//!< PIT CallBack Type
typedef void (*PDB_CallBackType)(void);

     
/* PDB Դ οChip configuration½ */
typedef enum
{
    kPDB_TriggerSrc0,
    kPDB_TriggerSrc1,
    kPDB_TriggerSrc2,
    kPDB_TriggerSrc3,
    kPDB_TriggerSrc4,
    kPDB_TriggerSrc5,
    kPDB_TriggerSrc6,
    kPDB_TriggerSrc7,
    kPDB_TriggerSrc8,
    kPDB_TriggerSrc9, 
    kPDB_TriggerSrc10,
    kPDB_TriggerSrc11,
    kPDB_TriggerSrc12,
    kPDB_TriggerSrc13,
    kPDB_TriggerSrc14,
    kPDB_SoftwareTrigger, 
}PDB_TriggerSrc_Type;

typedef enum
{
	kPWM_EdgeAligned,           //ض 
	kPWM_Combine,               //ģʽ
    kPWM_Complementary,         //ģʽ ģʽ Chl(n)  Chl(n+1) ǻ
}FTM_PWM_Mode_Type;
     
typedef struct
{
    uint32_t                srcClock;           // ʱԴƵ
    PDB_TriggerSrc_Type     inputTrigSource;    // 봥Դ
    bool                    isContinuesMode;    //Ƿģʽ
    uint32_t                timeInUs;
}PDB_InitTypeDef;

/*!< жϼDMA */
typedef enum
{
    kPDB_IT_CF,
    kPDB_DMA_CF,
}PDB_ITDMAConfig_Type;


//!< API functions
void PDB_QuickInit(PDB_TriggerSrc_Type triggerSrc, uint32_t timeInUs);
void PDB_Init(PDB_InitTypeDef * PDB_InitStruct);
void PDB_SoftwareTrigger(void);
void PDB_ITDMAConfig(PDB_ITDMAConfig_Type config, bool status);
void PDB_CallbackInstall(PDB_CallBackType AppCBFun);
uint32_t PDB_GetMODValue(void);
//!< ADC trigger function
void PDB_SetADCPreTrigger(uint32_t adcInstance, uint32_t adcMux, uint32_t dlyValue, bool status);
void PDB_SetBackToBackMode(uint32_t adcInstance, uint32_t adcMux, bool status);


#ifdef __cplusplus
}
#endif

#endif

