/* * Copyright (c) 2015, Freescale Semiconductor, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * o Redistributions of source code must retain the above copyright notice, this list
 *   of conditions and the following disclaimer.
 *
 * o Redistributions in binary form must reproduce the above copyright notice, this
 *   list of conditions and the following disclaimer in the documentation and/or
 *   other materials provided with the distribution.
 *
 * o Neither the name of Freescale Semiconductor, Inc. nor the names of its
 *   contributors may be used to endorse or promote products derived from this
 *   software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
  
 #include "vref.h"
 #include "common.h"
 
 /**
 * @brief  ʼVREF ģ
 * @param  DAC_InitTypeDef: ʼṹ
 * @retval None
 */
void VREF_Init(VREF_InitTypeDef *VREF_InitStruct)
{
    /* open clock gate */
    SIM->SCGC4 |= SIM_SCGC4_VREF_MASK;
    /* enable moudle */
    #ifdef VREF_SC_ICOMPEN_MASK
    VREF->SC = VREF_SC_VREFEN_MASK | VREF_SC_REGEN_MASK | VREF_SC_ICOMPEN_MASK | VREF_SC_MODE_LV(VREF_InitStruct->bufferMode);
    VREF->TRM |= VREF_TRM_CHOPEN_MASK;
    #else
    VREF->SC = VREF_SC_VREFEN_MASK | VREF_SC_REGEN_MASK  | VREF_SC_MODE_LV(VREF_InitStruct->bufferMode);
    #endif
    
}

 /**
 * @brief  ٳʼVREFģ
 * @note   VREFʼ Ҫ35MS ȶĲοѹ
 * @retval None
 */
void VREF_QuickInit(void)
{
    VREF_InitTypeDef  VREF_InitStruct1;
    VREF_InitStruct1.instance = 0;
    VREF_InitStruct1.bufferMode = kVREF_BufferMode_Lv1;
    VREF_Init(&VREF_InitStruct1);
}

 /**
 * @brief  ָVREFĬ״̬
 * @retval None
 */
void VREF_DeInit(void)
{
    SIM->SCGC4 &= ~SIM_SCGC4_VREF_MASK;
    VREF->SC = 0;
}

 /**
 * @brief  VREFУ׼ֵ
 * @param  У׼ֵ
 * @retval None
 */
void VREF_SetTrimValue(uint32_t val)
{
    VREF->TRM &= ~VREF_TRM_TRIM_MASK;
    VREF->TRM |= VREF_TRM_TRIM(val);
}
 
